#!/usr/bin/env python3

import subprocess

cores_list_1 = [1, 8]
cores_list_2 = [4, 2]
#data_list = ['yk', 'avazu-app', 'avazu-site', 'url', 'kdd10b', 'criteo', 'web_trigram', 'kdd12']
#data_list = ['news20', 'rcv1_test', 'covtype', 'yk', 'kdd10b', 'kdd12', 'eps', 'avazu-app', 'avazu-site', 'higgs', 'url', 'criteo', 'web_trigram']
#data_list = ['kdd12', 'eps', 'avazu-app', 'avazu-site', 'higgs', 'url', 'criteo', 'web_trigram']
#data_list = ['news20', 'rcv1_test', 'covtype', 'yk', 'kdd10b']
#data_list = ['yk', 'kdd10b', 'eps']
#data_list = ['news20', 'rcv1_test', 'kdda']
data_list = ['news20', 'rcv1_test', 'covtype', 'yk', 'kdda', 'kdd10b', 'kdd12', 'eps', 'avazu-app', 'avazu-site', 'higgs', 'url', 'criteo', 'web_trigram']
#data_list = ['kdda']

datas_path_dict = {\
'heart_scale':'/data/heart_scale',\
'news20':'/data/news20.binary', 
'criteo':'/data/criteo', \
'rcv1_test':'/data/rcv1_test.binary', \
'covtype':'/data/covtype', \
'yk':'/data/leisure', \
'eps':'/data/epsilon_normalized', \
'higgs':'/data/HIGGS', \
'kdd10b':'/data/kddb', \
'kdd12':'/data/kdd12', \
'url':'/data/url_combined', \
'web_trigram':'/data/webspam_wc_normalized_trigram',\
'avazu-site':'/data/avazu-site',\
'avazu-app':'/data/avazu-app',\
'kdda':'/data/kdda'
}

method_path_dict = {\
'cdn_svm':'/data/l1_parallel/code/check_speedup/npcd/',\
'cdn_lr':'/data/l1_parallel/code/check_speedup/liblinear-1.7-omp/',\
'bundle_cdn_svm':'/data/l1_parallel/code/pcdn_release_new_readme/',\
'bundle_cdn_lr':'/data/l1_parallel/code/pcdn_release_new_readme/',\
'bcdn_lr':'/data/l1_parallel/code/pcdn_release_new_readme/',\
'bcdn_svm':'/data/l1_parallel/code/pcdn_release_new_readme/',\
}

bundle_size_dict = {\
'kdda-bundle_cdn_svm':29500,\
'kdda-bundle_cdn_lr':95000,\
'kdda-bcdn_svm':29500,\
'kdda-bcdn_lr':95000,\
'news20-bundle_cdn_svm':150,\
'news20-bundle_cdn_lr':400,\
'news20-bcdn_svm':150,\
'news20-bcdn_lr':400,\
'rcv1_test-bundle_cdn_svm':350,\
'rcv1_test-bundle_cdn_lr':1600,\
'rcv1_test-bcdn_svm':350,\
'rcv1_test-bcdn_lr':1600,\
}

methods_list = ['bundle_cdn_svm', 'bundle_cdn_lr', 'bcdn_svm', 'bcdn_lr']
e = 0.01

def run(cmd):
    print(cmd)
    subprocess.call(cmd, shell=True)

log_dir_suffix = 'no.decay.cdn.speedup.log'
h = 1

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for core in cores_list_1:
        for method in methods_list:
            if data + '-' + method in bundle_size_dict:
                bundle_size = bundle_size_dict[data+'-'+method]
            else:
                bundle_size = 10000 
            if method == 'cdn_svm':
                cmd = '{method_dir}/train -s 5 -m 500 -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h)
            elif method == 'cdn_lr':
                cmd = '{method_dir}/train -s 6 -m 500 -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h)
            elif method == 'bundle_cdn_svm' and core != 1:
                cmd = '{method_dir}/train -a 2 -s 1 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bundle_cdn_lr' and core != 1:
                cmd = '{method_dir}/train -a 2 -s 0 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bcdn_lr' and core == 1:
                cmd = '{method_dir}/train -a 0 -s 0 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bcdn_svm' and core == 1:
                cmd = '{method_dir}/train -a 0 -s 1 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            else:
                continue
            run(cmd)

for data in data_list:
    for core in cores_list_2:
        for method in methods_list:
            if data + '-' + method in bundle_size_dict:
                bundle_size = bundle_size_dict[data+'-'+method]
            else:
                bundle_size = 10000 
            if method == 'cdn_svm':
                cmd = '{method_dir}/train -s 5 -m 500 -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h)
            elif method == 'cdn_lr':
                cmd = '{method_dir}/train -s 6 -m 500 -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h)
            elif method == 'bundle_cdn_svm' and core != 1:
                cmd = '{method_dir}/train -a 2 -s 1 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bundle_cdn_lr' and core != 1:
                cmd = '{method_dir}/train -a 2 -s 0 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bcdn_lr' and core == 1:
                cmd = '{method_dir}/train -a 0 -s 0 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            elif method == 'bcdn_svm' and core == 1:
                cmd = '{method_dir}/train -a 0 -s 1 -c {c} -t {num_threads} -b {bundle_size} {data_path} /data/heart_scale > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, bundle_size = bundle_size)
            else:
                continue
            run(cmd)
